;****************************************************************************
;*
;*	INTRUDER support for the dos extender by doug huffman
;*
;*	uilm - written 1997 by future vision
;*
;*	tasm compatible source code
;*
;****************************************************************************

.386P

Black		EQU	0
Blue		EQU	1
Green		EQU	2
Cyan		EQU	3
Red		EQU	4
Magenta 	EQU	5
Brown		EQU	6
LightGray	EQU	7

DarkGray	EQU	8
LightBlue	EQU	9
LightGreen	EQU	10
LightCyan	EQU	11
LightRed	EQU	12
LightMagenta	EQU	13
Yellow		EQU	14
White		EQU	15

set_color	MACRO	background,foreground
		mov		[color],(background)*16+foreground
		ENDM

main_seg		SEGMENT	USE16
	ASSUME	CS:main_seg
	ASSUME	DS:main_seg
	ORG	100h

com_entry:	jmp	start_up
	ORG	103h
		DB	'UILM'				;sign
		DW	offset low_mem_end-100h		;size
		DD	0				;no xms
		DD	0
		DW	0011111111b			;features
;			 ^8  ^4  ^0
;internal hotkey and menu calls only

		DB	0				;no def hotkey
		DW	0				;no def intern hotkey
		DW	0				;reserved
		DB	'D Huffman''s extender',0	;name

start_up		PROC	NEAR
;save offset table addr
		mov		word ptr cs:[offset_table],si
		mov		word ptr cs:[offset_table+2],ds
;where from?
		mov		ah,0
		int		32h
		cmp		ax,'IS'
		jne	dos_call
		test		cl,100b
		jz	dos_call
;init segs
		mov		ax,cs			;set data seg
		mov		ds,ax
		mov		es,ax
;draw win
		set_color	blue,white
		mov		di,160*8
		mov		al,0c9h
		call	write_char
		mov		al,0cdh
		call	write_line
		mov		al,0bbh
		call	write_char
		mov		cx,10
@@win_draw:	mov		al,0bah
		call	write_char
		mov		al,' '
		call	write_line
		mov		al,0bah
		call	write_char
		loop	@@win_draw
		mov		al,0c8h
		call	write_char
		mov		al,0cdh
		call	write_line
		mov		al,0bch
		call	write_char
		mov		di,160*8+4
		set_color	blue,lightgray
		mov		si,offset $win
		call	write_string
		set_color	blue,yellow
		mov		di,160*11+4
;check v86 mode
		smsw		ax
		test		al,1
		jz	@@vm_ok
		mov		si,offset $vm
		jmp	@@error_terminate
;ok, get gdt addr and size
@@vm_ok:	mov		si,offset $scanning
		call	write_string
		lgs		si,[offset_table]
		mov		si,gs:[si+4]
		mov		ax,gs:[si]
		mov		[gdt_size],ax
		mov		eax,gs:[si+2]
		mov		[gdt_addr],eax
		push		di
		mov		di,offset $extender
;search for extender name in memory
		mov		esi,[gdt_addr]
		mov		cl,12
		mov		ah,1bh
		int		32h
		push		ds
		pop		es
		jnc	@@found
@@not_found:	pop		di
		mov		si,offset $not_found
		jmp	@@error_terminate
@@found:
;within following 800h bytes?
		sub		esi,[gdt_addr]
		sub		esi,800h
		jns	@@not_found
;ok, search for rm idt
		mov		di,offset rm_idt
		mov		esi,[gdt_addr]
		mov		cl,6
		mov		ah,1bh
		int		32h
		push		ds
		pop		es
		jc	@@not_found
;save addr, within max range?
		sub		esi,6
		mov		[idt_addr],esi
		sub		esi,[gdt_addr]
		sub		esi,800h
		jns	@@not_found
		pop		di
		mov		si,offset $found
		call	write_string
;load seg:offs of lidt data
		mov		eax,[idt_addr]
		mov		si,ax
		shr		eax,4
		and		si,0fh
		mov		fs,ax
;use it to load cr3 contents if used
		mov		[page_addr],0
		mov		eax,fs:[si+2]
		mov		[idt_addr],eax
		test		byte ptr fs:[si+10h+3],80h
		jz	@@no_paging
		mov		eax,fs:[si+30h]
		mov		[page_addr],eax
;ok, got gdt_addr, idt_addr, page_addr
@@no_paging:
;display them all
		mov		di,160*13+4
		mov		ah,20h
		mov		bl,1fh
		int		32h
		mov		ah,23h
		mov		bx,1008h
		int		32h
		mov		si,offset $gdt
		call	write_string
		mov		ah,21h
		mov		bx,di
		int		32h
		mov		ebx,[gdt_addr]
		mov		ah,24h
		int		32h
		mov		di,160*14+4
		mov		si,offset $idt
		call	write_string
		mov		ah,21h
		mov		bx,di
		int		32h
		mov		ebx,[idt_addr]
		mov		ah,24h
		int		32h
		mov		di,160*15+4
		mov		si,offset $page
		call	write_string
		mov		ah,21h
		mov		bx,di
		int		32h
		mov		ebx,[page_addr]
		mov		ah,24h
		int		32h
		mov		di,160*16+4
		mov		si,offset $intrude
		call	write_string
		mov		ah,0
		int		16h
		cmp		al,'i'
		jne	@@terminate
;intrude if 'i' pressed
		mov		edi,[page_addr]
		mov		ebx,[idt_addr]
		mov		edx,[gdt_addr]
		mov		cl,17
		mov		ch,18
		mov		ah,0dh
		xor		esi,esi
		int		32h
		mov		si,offset $done
		mov		di,160*18+4
;and return
@@error_terminate:
		call	write_string
		mov		ah,0
		int		16h
@@terminate:	xor		al,al
		retf
start_up		ENDP

color		DB	1fh
gdt_size	DW	?
gdt_addr	DD	?
idt_addr	DD	?
page_addr	DD	0
rm_idt		DB	0ffh,003h,000h,000h,000h,000h

$vm		DB	'processor in v86 mode...cannot continue',0
$scanning	DB	'scanning for the dos extender...',0
$found		DB	'found',0
$not_found	DB	'not found',0
$done		DB	'protected mode work enabled',0
$win		DB	' '
$extender	DB	'Doug Huffman''s dos extender ',0
$gdt		DB	'gdt      : ',0
$idt		DB	'idt      : ',0
$page		DB	'page dir : ',0
$intrude	DB	'press ''I'' to intrude',0

offset_table	DD	?

write_char		PROC	NEAR
		push		ax
		push		es
		push		0b800h
		pop		es
		mov		ah,[color]
		stosw
		pop		es
		pop		ax
		ret
write_char		ENDP

write_line		PROC	NEAR
	LOCALS
		push		cx
		mov		cx,78
@@line_loop:	call	write_char
		loop	@@line_loop
		pop		cx
		ret
write_line		ENDP
write_string		PROC	NEAR
	LOCALS
		push		ax
@@loop_string:	lodsb
		or		al,al
		jz	@@end_string
		call	write_char
		jmp	@@loop_string
@@end_string:	pop		ax
		ret
write_string		ENDP

low_mem_end		LABEL	WORD


dos_call		PROC	NEAR
		mov		dx,offset $no_dos
		mov		ah,9h
		int		21h
		mov		ax,4c00h
		int		21h
dos_call		ENDP
$no_dos		DB	'This UILM enables protected mode debug work with the DOS extender by',13,10
		DB	'Doug Huffman',13,10
		DB	'...written 1996 by FUTURE VISION',13,10,'$'
main_seg		ENDS
			END	com_entry
